diff -Nur linux-2.4.30/drivers/mmc/mmc_au1x.c linux-2.4.30-linux-mips.org/drivers/mmc/mmc_au1x.c
--- linux-2.4.30/drivers/mmc/mmc_au1x.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/mmc/mmc_au1x.c	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,1730 @@
+/*
+ * BRIEF MODULE DESCRIPTION
+ *	MMC framework driver for MMC/SD controllers on the
+ *	Alchemy Au1100 mips processor.  Although the Au1100
+ *	controllers are "Secure Digital" controllers, this
+ *	module only provides a (non-secure) MultiMediaCard
+ *	interface conforming to the MMC framework as developed
+ *	by Andrew Christian.
+ *
+ *	The original MMC framework patch is located at
+ *	//handhelds.org/download/linux/mmc/patch-2.4.19-mmc
+ *
+ *	Thanks to early users of the card whose input helped
+ *	clarify things, such as status bit interpretations in
+ *	pio mode.
+ *
+ *	Portions below, including but not limited to support of
+ *	dynamic media insertion/removal, were derived from a
+ *	Metrowerks driver, which itself was based on code for
+ *	the iPAQ H3800.  Required copyright notices have been
+ *	included below from those sources.
+ *
+ *
+ * Copyright (c) 2003-2004 Embedded Edge, LLC.
+ * Author: Embedded Edge, LLC.
+ * Contact: dan@embeddededge.com
+ *
+ *  This program is free software; you can redistribute  it and/or modify it
+ *  under  the terms of  the GNU General  Public License as published by the
+ *  Free Software Foundation;  either version 2 of the  License, or (at your
+ *  option) any later version.
+ *
+ *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
+ *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
+ *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
+ *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
+ *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
+ *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
+ *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
+ *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  You should have received a copy of the  GNU General Public License along
+ *  with this program; if not, write  to the Free Software Foundation, Inc.,
+ *  675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
+
+/*
+ * Low-level MMC functions for the AMD db1100 EVB.
+ *
+ *  Portions Copyright (C) 2002 Embedix, Inc
+ *  Originally based on code for the iPAQ H3800, see below.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
+ */
+
+/*
+ * Low-level MMC functions for the iPAQ H3800
+ *
+ * Copyright 2002 Hewlett-Packard Company
+ *
+ * Use consistent with the GNU GPL is permitted,
+ * provided that this copyright notice is
+ * preserved in its entirety in all copies and derived works.
+ *
+ * HEWLETT-PACKARD COMPANY MAKES NO WARRANTIES, EXPRESSED OR IMPLIED,
+ * AS TO THE USEFULNESS OR CORRECTNESS OF THIS CODE OR ITS
+ * FITNESS FOR ANY PARTICULAR PURPOSE.
+ *
+ * Many thanks to Alessandro Rubini and Jonathan Corbet!
+ *
+ * Author:  Andrew Christian
+ *          6 May 2002
+ */
+
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/mmc/mmc_ll.h>
+#include <asm/irq.h>
+#include <asm/au1000.h>
+#include <asm/au1xxx_dbdma.h> 
+#include <asm/au1100_mmc.h>
+
+#if defined(CONFIG_SOC_AU1100)
+#include <asm/au1000_dma.h>
+#define AU1X_MMC_INT AU1100_SD_INT
+
+#elif defined(CONFIG_SOC_AU1200)
+#include <asm/au1xxx_dbdma.h> 
+#define NUM_DBDMA_DESCRIPTORS         2    /*  Number of Descriptor for DDMA */
+#define AU1X_MMC_INT AU1200_SD_INT
+
+#else
+#error "mmc_au1x.c: error unsupported SOC"
+#endif
+
+/*
+ *  Boot options:
+ */
+int au1x_mmc_use_pio =0 ;	/* Force PIO - default is use DMA channels */
+int au1x_mmc_dbl_buf = 0;	/* For DMA, double buffer - use for unaligned requests */
+int au1x_mmc_ctlr = 0;		/* Which SD controller(s) to enable -- SD0 is default */
+
+/*
+ *  Tunable quantum of PIO transfer - (11 bits available).
+ */
+#define AU1X_MMC_CHUNK_SIZE 128
+
+/*
+ *  Timeouts.
+ */
+#define MMC_IRQ_TIMEOUT  (3 * HZ)
+#define MMC_DETECT_TIMEOUT  (HZ/2)
+
+/*
+ *  Controller state flags.
+ */
+#define AU_MMC_STATE_MODULE_INITTED	(1<<0)	/* module-wide init - used in ctlr #0 flags only */
+#define AU_MMC_STATE_CTLR_ACTIVE	(1<<1)
+//#define AU_MMC_STATE_x		(1<<2)
+//#define AU_MMC_STATE_x		(1<<3)
+#define AU_MMC_STATE_USE_DMA		(1<<4)
+#define AU_MMC_STATE_DOUBLE_BUFFER_DMA	(1<<5)
+#define AU_MMC_STATE_RECV_DMA_IN_USE	(1<<6) 
+#define AU_MMC_STATE_XMIT_ACTIVE	(1<<7)
+
+ 
+   
+
+
+/*
+ *  Per card/controller description.
+ */
+static struct au1x_mmc_card
+{
+	struct timer_list	 m_detect_timer;
+	struct timer_list	 m_irq_timer;	/* Panic timer - make sure we get
+	                                         * a response */
+	int			 m_ctlr;	/* controller number */
+	u32			 m_base;	/* base of register block */
+	u32			 m_clock;	/* card clock rate */
+	int			 m_flags;	/* see above flag defs */
+	int			 m_isempty;	/* to avoid needing lock for flags */
+	struct mmc_request	*m_req;		/* upper level request */
+	int			 m_cnt;		/* bytes processed so far */
+	int			 m_tx_dma_devid;/* DMA channel identifiers */
+	int			 m_rx_dma_devid;
+	const char		*m_tx_dma_str;
+	const char		*m_rx_dma_str;
+	int			 m_xmit_dma;	/* transmit dma channel # */
+	int			 m_recv_dma;	/* receive dma channel # */
+	void			*m_tx_rawbuf;	/* transmit buffer */
+	void			*m_rx_rawbuf;	/* receive buffer */
+	dma_addr_t		m_tx_dmaaddr;	/*  virt_to_phys(buffer) */
+	dma_addr_t		m_rx_dmaaddr;
+ 	int			 m_dma_memsize;	/* byte size of each rawbuf */
+#ifdef CONFIG_SOC_AU1200
+	chan_tab_t	**ctp_tx;  /*Channel Tab Pointer to Transmit*/
+	chan_tab_t	**ctp_rx;  /*Channel Tab Pointer to recieve*/
+#endif
+} au1x_mmc_card_table[] =
+{
+	{
+		m_ctlr: 0,
+		m_base:	SD0_BASE,
+		m_clock: MMC_CLOCK_SLOW, /* for starters - changed later */
+		m_flags: (AU_MMC_STATE_USE_DMA
+			/* | AU_MMC_STATE_DOUBLE_BUFFER_DMA */),
+		m_isempty: 1,
+#ifdef CONFIG_SOC_AU1100
+		m_tx_dma_devid: DMA_NUM_DEV + DMA_ID_SD0_TX, // bank #2
+		m_rx_dma_devid: DMA_NUM_DEV + DMA_ID_SD0_RX, // bank #2
+#endif
+#ifdef CONFIG_SOC_AU1200
+		m_tx_dma_devid: DSCR_CMD0_SDMS_TX0, /* defined in dbdma.h*/
+		m_rx_dma_devid: DSCR_CMD0_SDMS_RX0, /* defined in dbdma.h */
+#endif
+                m_tx_dma_str: "MMC/SD #0 XMIT",
+		m_rx_dma_str: "MMC/SD #0 RECV",
+		m_xmit_dma: -1,
+		m_recv_dma: -1,
+	},
+
+#if (NUM_MMC_CONTROLLERS > 1)
+	{
+		m_ctlr: 1,
+		m_base:	SD1_BASE,
+		m_clock: MMC_CLOCK_SLOW, /* for starters - changed later */
+		m_flags: (AU_MMC_STATE_USE_DMA
+			/* | AU_MMC_STATE_DOUBLE_BUFFER_DMA */),
+		m_isempty: 1,
+
+#ifdef CONFIG_SOC_AU1100
+		m_tx_dma_devid: DMA_NUM_DEV + DMA_ID_SD1_TX, // bank #2
+		m_rx_dma_devid: DMA_NUM_DEV + DMA_ID_SD1_RX, // bank #2
+#endif
+#ifdef CONFIG_SOC_AU1200
+		m_tx_dma_devid:  DSCR_CMD0_SDMS_TX1, /* defined in dbdma.h*/
+		m_rx_dma_devid:  DSCR_CMD0_SDMS_RX1, /* defined in dbdma.h*/ 
+#endif
+	        m_tx_dma_str: "MMC/SD #1 XMIT",
+		m_rx_dma_str: "MMC/SD #1 RECV",
+		m_xmit_dma: -1,
+		m_recv_dma: -1,
+	},
+#endif
+};
+
+/* Ptrs for descriptor access */
+static struct au1x_mmc_card *au1x_mmc_cards[NUM_MMC_CONTROLLERS];
+
+/*
+ * Macro to extract which controller to service incoming request.
+ * Currently, outer framework doesn't handle multiple controllers,
+ * so this macro really is for future expansion.
+ */
+static int mmc_active_ctlr = -1;
+#define CTLR_SELECT(_i_)	(mmc_active_ctlr)
+#define SLOT_SELECT(_i_)	(0)
+
+
+/*
+ *  Access macros.
+ */
+#define CARD_STATUS(c)	((c)->m_base + SD_STATUS)
+#define CARD_CONFIG(c)	((c)->m_base + SD_CONFIG)
+#define CARD_ENABLE(c)	((c)->m_base + SD_ENABLE)
+#define CARD_TXPORT(c)	((c)->m_base + SD_TXPORT)
+#define CARD_RXPORT(c)	((c)->m_base + SD_RXPORT)
+#define CARD_CMDARG(c)	((c)->m_base + SD_CMDARG)
+#define CARD_BLKSIZE(c)	((c)->m_base + SD_BLKSIZE)
+#define CARD_CMD(c)	((c)->m_base + SD_CMD)
+#define CARD_CONFIG2(c)	((c)->m_base + SD_CONFIG2)
+#define CARD_TIMEOUT(c)	((c)->m_base + SD_TIMEOUT)
+#define CARD_DEBUG(c)	((c)->m_base + SD_DEBUG)
+
+
+
+/*
+ *  OCR value to use - thanks, Metrowerks
+ */
+#define MMC_VDD_RANGES	( \
+		MMC_VDD_27_28	| \
+		MMC_VDD_28_29	| \
+		MMC_VDD_29_30	| \
+		MMC_VDD_30_31	| \
+		MMC_VDD_31_32	| \
+		MMC_VDD_32_33	| \
+		MMC_VDD_33_34	| \
+		MMC_VDD_34_35	| \
+		MMC_VDD_35_36)
+
+/*
+ *  Internal forward declarations.
+ */
+static	int	mmc_reset_controller(struct au1x_mmc_card *card, u32 rate);
+static	int	au1x_mmc_check_insert(int mmc);
+
+/*
+ *  Forward declarations for MMC framework interface.
+ */
+static	int	au1x_mmc_init(void);
+static	void	au1x_mmc_cleanup(void);
+static	int	au1x_mmc_is_empty(int slot);
+static	int	au1x_mmc_set_clock(int slot, u32 rate);
+static	void	au1x_mmc_send_cmd(struct mmc_request *);
+
+static struct mmc_slot_driver au1x_mmc_driver =
+{
+	owner:		THIS_MODULE,
+	name:		"Au1x MMC Controller",
+	ocr:		MMC_VDD_RANGES,
+	flags:		MMC_SDFLAG_MMC_MODE,
+
+	init:		au1x_mmc_init,
+	cleanup:	au1x_mmc_cleanup,
+	is_empty:	au1x_mmc_is_empty,
+	set_clock:	au1x_mmc_set_clock,
+	send_cmd:	au1x_mmc_send_cmd
+};
+
+
+
+static void au1x_mmc_send_data_pio(struct au1x_mmc_card *card)
+{
+	struct mmc_request *req = card->m_req;
+	int		    cnt = card->m_cnt;
+	int		    i = AU1X_MMC_CHUNK_SIZE;
+
+	while (au_readl(CARD_STATUS(card)) & (SD_STATUS_TA | SD_STATUS_TH)) {
+
+		if (cnt == req->block_len) {
+			au_writel(au_readl(CARD_CONFIG(card)) & ~SD_CONFIG_TH,
+				CARD_CONFIG(card));
+			au_sync();
+			break;
+		}
+		au_writel(req->buffer[cnt++], CARD_TXPORT(card));
+		au_sync();
+		if (! i--) {
+			break;
+		}
+	}
+
+	DEBUG(3, ": Sent %d bytes, total so far %d\n",
+		cnt - card->m_cnt, cnt);
+
+	card->m_cnt = cnt;
+}
+
+
+static void au1x_mmc_receive_data_pio(struct au1x_mmc_card *card)
+{
+	struct mmc_request *req = card->m_req;
+	int		    cnt = card->m_cnt;
+	int		    i = AU1X_MMC_CHUNK_SIZE;
+
+	while (au_readl(CARD_STATUS(card)) & SD_STATUS_NE) {
+		if (cnt == req->block_len) {
+			break;
+		}
+
+		req->buffer[cnt++] = au_readl(CARD_RXPORT(card));
+		if (! i--) {
+			break;
+		}
+	}
+
+	DEBUG(3, ": Rcvd %d bytes, total so far %d, total requested %d\n",
+		cnt - card->m_cnt, cnt, req->block_len);
+
+	card->m_cnt = cnt;
+}
+
+
+static void au1x_mmc_send_data_dma(struct au1x_mmc_card *card)
+{ 
+#ifdef CONFIG_SOC_AU1200
+	struct mmc_request *req = card->m_req;
+	chan_tab_t *chanpt;
+	volatile au1x_dma_chan_t *cp;  
+
+	chanpt= *((chan_tab_t**)(card->ctp_tx)); 
+	cp =chanpt->chan_ptr;        
+
+	if (card->m_tx_rawbuf) {
+		memcpy(card->m_tx_rawbuf, req->buffer, req->block_len);
+	} else {
+		card->m_tx_dmaaddr = virt_to_phys(req->buffer);
+	}
+
+	/*Start the DBDMA Channel*/           
+	au1xxx_dbdma_start((u32)(card->ctp_tx));
+
+       if( ! au1xxx_dbdma_put_source((u32)(card->ctp_tx),card->m_tx_dmaaddr,req->block_len ))
+				      
+                                      {				 
+					 printk("DBDMA Error..Putting Descriptor on Buffer Ring Channel A in Single Channel \n");
+					 
+				       }
+
+	card->m_cnt = req->block_len;
+	au_sync();
+
+	/* to check if channel is halted*/
+	if  (cp->ddma_stat & DDMA_STAT_H )
+		au1xxx_dbdma_start((u32)(card->ctp_tx));
+#endif
+#ifdef CONFIG_SOC_AU1100
+	struct mmc_request *req = card->m_req;
+	int		    chan = card->m_xmit_dma;
+
+	if (card->m_tx_rawbuf) {
+		memcpy(card->m_tx_rawbuf, req->buffer, req->block_len);
+	} else {
+		card->m_tx_dmaaddr = virt_to_phys(req->buffer);
+	}
+
+	if (get_dma_active_buffer(chan) == 1) {
+		clear_dma_done1(chan);
+		set_dma_count1(chan, req->block_len);
+		set_dma_count0(chan, 0);
+		set_dma_addr1(chan, card->m_tx_dmaaddr);
+		enable_dma_buffer1(chan);
+	} else {
+		clear_dma_done0(chan);
+		set_dma_count0(chan, req->block_len);
+		set_dma_count1(chan, 0);
+		set_dma_addr0(chan, card->m_tx_dmaaddr);
+		enable_dma_buffer0(chan);
+	}
+
+	card->m_cnt = req->block_len;
+	au_sync();
+
+	if (dma_halted(chan))
+		start_dma(chan);
+#endif
+}
+
+
+static void au1x_mmc_receive_data_dma(struct au1x_mmc_card *card)
+{
+#ifdef CONFIG_SOC_AU1200
+        struct mmc_request *req = card->m_req;
+        chan_tab_t        *chanpt;
+        volatile au1x_dma_chan_t *cp;  
+        
+         chanpt= *((chan_tab_t**)(card->ctp_tx)); 
+          cp =chanpt->chan_ptr;            
+
+
+     	if (card->m_flags & AU_MMC_STATE_RECV_DMA_IN_USE) {
+		/* spurious */
+		return;
+	}
+
+	card->m_flags |= AU_MMC_STATE_RECV_DMA_IN_USE;
+
+	/*
+	 *  Data is ready for reading.  Disable this interrupt
+	 *  as the DMA engine now takes over.  The transfer done
+	 *  interrupt will serve to let us know when data has
+	 *  been moved.
+	 */
+
+
+	au_writel(au_readl(CARD_CONFIG(card)) & ~SD_CONFIG_NE,
+		CARD_CONFIG(card));
+	au_sync();
+
+	if ( ! (card->m_rx_rawbuf) ) {
+		card->m_rx_dmaaddr = virt_to_phys(req->buffer);
+	 }
+
+            au1xxx_dbdma_start((u32)(card->ctp_rx));
+
+	
+   
+	    if( ! au1xxx_dbdma_put_dest((u32)(card->ctp_rx),card->m_rx_dmaaddr,req->block_len))
+				      
+                                      {				 
+					 printk("DBDMA PUT DESC Error..Putting Descriptor on Buffer Ring Channel A in Single Channel \n");
+	                              }
+				     
+           
+             card->m_cnt = req->block_len;
+             au_sync();
+
+
+	if  (cp->ddma_stat & DDMA_STAT_H )
+	  au1xxx_dbdma_start((u32)(card->ctp_rx));
+#endif
+#ifdef CONFIG_SOC_AU1100
+	struct mmc_request *req = card->m_req;
+	int		    chan = card->m_recv_dma;
+
+	if (card->m_flags & AU_MMC_STATE_RECV_DMA_IN_USE) {
+		/* spurious */
+		return;
+	}
+
+	card->m_flags |= AU_MMC_STATE_RECV_DMA_IN_USE;
+
+	/*
+	 *  Data is ready for reading.  Disable this interrupt
+	 *  as the DMA engine now takes over.  The transfer done
+	 *  interrupt will serve to let us know when data has
+	 *  been moved.
+	 */
+	au_writel(au_readl(CARD_CONFIG(card)) & ~SD_CONFIG_NE,
+		CARD_CONFIG(card));
+	au_sync();
+
+	if ( ! (card->m_rx_rawbuf) ) {
+		card->m_rx_dmaaddr = virt_to_phys(req->buffer);
+	}
+
+	if (get_dma_active_buffer(chan) == 1) {
+		clear_dma_done1(chan);
+		set_dma_count1(chan, req->block_len);
+		set_dma_count0(chan, 0);
+		set_dma_addr1(chan, card->m_rx_dmaaddr);
+		enable_dma_buffer1(chan);
+	} else {
+		clear_dma_done0(chan);
+		set_dma_count0(chan, req->block_len);
+		set_dma_count1(chan, 0);
+		set_dma_addr0(chan, card->m_rx_dmaaddr);
+		enable_dma_buffer0(chan);
+	}
+
+	card->m_cnt = req->block_len;
+	au_sync();
+
+	if (dma_halted(chan))
+		start_dma(chan);
+#endif
+}
+
+
+static void au1x_mmc_dma_complete(struct au1x_mmc_card *card)
+{
+#ifdef CONFIG_SOC_AU1200
+	int chan = 0; //To get rid of complilation error
+	volatile au1x_dma_chan_t *cp; 
+	chan_tab_t *chanpt;
+
+	if (card->m_flags & AU_MMC_STATE_XMIT_ACTIVE)
+		{
+	
+             	  chan = card->m_xmit_dma;
+		 chanpt= *((chan_tab_t**)(card->ctp_tx));
+                 cp = chanpt->chan_ptr;
+		}   
+            else
+	      {
+		chan= card->m_recv_dma;
+		chanpt= *((chan_tab_t**)(card->ctp_rx));
+	        cp= chanpt->chan_ptr;
+	      }
+
+	/*
+	 *  On receive, MMC may signal xfer is done before dma
+	 *  engine has finished reading the fifo and actually
+	 *  transfering data to memory.  A small window perhaps,
+	 *  but we wait until the engine says it's through too.
+	 */
+	while((cp->ddma_stat & DDMA_STAT_V)==1){
+	
+	  DEBUG(1, ": waiting for MMC DMA completion.\n");
+	  au_sync();
+	}
+            
+	if (card->m_flags & AU_MMC_STATE_RECV_DMA_IN_USE) {
+		card->m_flags &= ~AU_MMC_STATE_RECV_DMA_IN_USE;
+
+		if (card->m_rx_rawbuf) {
+			memcpy( card->m_req->buffer,
+				card->m_rx_rawbuf,
+				card->m_cnt);
+		}
+	}
+#endif
+#ifdef CONFIG_SOC_AU1100
+	unsigned int buf_done;
+	int chan;
+
+	if (card->m_flags & AU_MMC_STATE_XMIT_ACTIVE)
+		chan = card->m_xmit_dma;
+	else
+		chan = card->m_recv_dma;
+
+	/*
+	 *  On receive, MMC may signal xfer is done before dma
+	 *  engine has finished reading the fifo and actually
+	 *  transfering data to memory.  A small window perhaps,
+	 *  but we wait until the engine says it's through too.
+	 */
+	while ((buf_done = get_dma_buffer_done(chan)) == 0) {
+		DEBUG(1, ": waiting for MMC DMA completion.\n");
+
+		au_sync();
+	}
+
+	if (buf_done == (DMA_D0 | DMA_D1)) {
+		DEBUG(0, ": MMC DMA error - multiple outstanding buffers\n");
+
+		card->m_cnt = 0;	// signal error
+
+		init_dma(chan);		// reset dma channel
+		au_sync();
+	} else if (buf_done == DMA_D1) {
+		clear_dma_done1(chan);
+	} else {
+		clear_dma_done0(chan);
+	}
+
+	if (card->m_flags & AU_MMC_STATE_RECV_DMA_IN_USE) {
+		card->m_flags &= ~AU_MMC_STATE_RECV_DMA_IN_USE;
+
+		if (card->m_rx_rawbuf) {
+			memcpy( card->m_req->buffer,
+				card->m_rx_rawbuf,
+				card->m_cnt);
+		}
+	}
+#endif
+}
+
+
+static void au1x_mmc_cmd_ack(struct au1x_mmc_card *card)
+{
+	struct mmc_request *req = card->m_req;
+	int base = card->m_base;
+
+	switch (req->rtype) {
+
+	case RESPONSE_NONE:
+		break;
+
+	case RESPONSE_R3:
+	case RESPONSE_R1:
+	case RESPONSE_R1B:
+	  {
+		u8 header = au_readl(base + SD_RESP1);
+		u32 ocr = au_readl(base + SD_RESP0);
+
+		req->response[0] = header;
+		req->response[1] = (ocr >> 24) & 0xff;
+		req->response[2] = (ocr >> 16) & 0xff;
+		req->response[3] = (ocr >>  8) & 0xff;
+		req->response[4] = (ocr) & 0xff;
+		break;
+	  }
+
+	case RESPONSE_R2_CID:
+	case RESPONSE_R2_CSD:
+	  {
+		u32 reg[4];
+		int i;
+
+		reg[0] = au_readl(base + SD_RESP3);
+		reg[1] = au_readl(base + SD_RESP2);
+		reg[2] = au_readl(base + SD_RESP1);
+		reg[3] = au_readl(base + SD_RESP0);
+
+		for (i = 0; i < 4; i++) {
+			if (i) {
+				req->response[i*4] = (reg[i] >> 24) & 0xff;
+			}
+			req->response[i*4 + 1] = (reg[i] >> 16) & 0xff;
+			req->response[i*4 + 2] = (reg[i] >> 8) & 0xff;
+			req->response[i*4 + 3] = (reg[i]) & 0xff;
+		}
+		req->response[0] = 0x3f;
+		break;
+	  }
+
+	case RESPONSE_R4:
+	case RESPONSE_R5:
+	default:
+		DEBUG(0, ": Unsupported MMC response type %d\n", req->rtype);
+		req->result = MMC_ERROR_DRIVER_FAILURE;
+		break;
+	}
+
+	req->result = MMC_NO_ERROR;
+	if (!req->nob) {
+		del_timer_sync(&card->m_irq_timer);
+		mmc_cmd_complete(req);
+	} else {
+		/*
+		 *  Reset timer for data phase of command.
+		 */
+		mod_timer(&card->m_irq_timer, jiffies + MMC_IRQ_TIMEOUT);
+	}
+}
+
+
+#define SD_STATUS_ERRORS ( \
+		SD_STATUS_RAT	| \
+		SD_STATUS_DT	| \
+		SD_STATUS_SC	| \
+		SD_STATUS_RC	| \
+		SD_STATUS_WC	| \
+		SD_STATUS_TU	| \
+		SD_STATUS_RU	| \
+		SD_STATUS_TO	| \
+		SD_STATUS_RO )
+
+static void au1x_mmc_irq(int irq, void *dev_id, struct pt_regs *regs)
+{
+	int mmc;
+
+       
+
+	disable_irq(AU1X_MMC_INT);
+
+	/*
+	 *  Traverse all irq sources.
+	 */
+	for (mmc = 0; mmc < NUM_MMC_CONTROLLERS; ++mmc) {
+
+		u32 status, debug;
+		int tmo;
+		struct au1x_mmc_card *card = au1x_mmc_cards[mmc];
+
+		int tx = card->m_flags & AU_MMC_STATE_XMIT_ACTIVE;
+		int dma = card->m_flags & AU_MMC_STATE_USE_DMA;
+
+                
+                
+
+		/*
+		 *  Punt if this controller has been designated inactive.
+		 */
+		if ( ! (card->m_flags & AU_MMC_STATE_CTLR_ACTIVE) )
+			continue;
+
+		status = au_readl(CARD_STATUS(card));
+		debug = au_readl(CARD_DEBUG(card));
+
+		/* matching dev_id means timeout */
+		tmo = (dev_id == ((void *) card));
+
+		
+
+		if ( (!(status & SD_STATUS_I)) && !tmo ){
+		   continue;
+		}
+
+		DEBUG((tmo?0:2), ": %s" "card %d status 0x%08X\n", (tmo?"timeout ":""), mmc, status);
+
+		/*
+		 *  Check errors.
+		 */
+		if (status & (SD_STATUS_ERRORS)) {
+			if (status & (SD_STATUS_RAT
+				      | SD_STATUS_DT)) {
+				card->m_req->result = MMC_ERROR_TIMEOUT;
+				goto terminate_int;
+			}
+
+			if (status & (SD_STATUS_SC
+				      | SD_STATUS_RC
+				      | SD_STATUS_WC)) {
+				card->m_req->result = MMC_ERROR_CRC;
+				goto terminate_int;
+			}
+
+			if (status & (SD_STATUS_TU
+				      | SD_STATUS_RU)) {
+				card->m_req->result = MMC_ERROR_UNDERRUN;
+				goto terminate_int;
+			}
+
+			if (status & (SD_STATUS_TO
+				      | SD_STATUS_RO)) {
+				card->m_req->result = MMC_ERROR_OVERRUN;
+				goto terminate_int;
+			}
+		} else if (tmo) {
+			/*
+			 *  No discernible error, but we have a timeout.
+			 */
+			card->m_req->result = MMC_ERROR_GENERAL;
+			goto terminate_int;
+		}
+
+		/*
+		 *  Command response.
+		 */
+		if (status & SD_STATUS_CR) {
+			au1x_mmc_cmd_ack(card);
+
+			if (tx) {
+				if (dma) {
+					au1x_mmc_send_data_dma(card);
+				} else {
+					au_writel(au_readl(CARD_CONFIG(card))
+							| SD_CONFIG_TH,
+						CARD_CONFIG(card));
+					au_sync();
+					if (status & ( SD_STATUS_TH
+						     | SD_STATUS_TA
+						     | SD_STATUS_TE)) {
+						au1x_mmc_send_data_pio(card);
+					}
+				}
+			} else {
+				/*
+				 *  Optimization.  Re-read status to possibly
+				 *  catch RX Data-Ready instead of incurring
+				 *  additional interrupt to tell us so.
+				 */
+				u32 status2;
+				au_sync();
+				status2 = au_readl(CARD_STATUS(card));
+				if (status2 != status) {
+					DEBUG(2, ": card %d status2 0x%08X\n",
+						mmc, status2);
+
+					status |= status2;
+				}
+
+				if (dma && (status & SD_STATUS_DB)) {
+					/*
+					 *  Bits are moving into the FIFO.
+					 *  Fire up the bit mover.
+					 */
+				  
+					au1x_mmc_receive_data_dma(card);
+	
+				}
+			}
+		} else if (status & (SD_STATUS_TA | SD_STATUS_TE)) {
+			if (tx && !dma) {
+				au1x_mmc_send_data_pio(card);
+			}
+		}
+
+		/*
+		 *  Data done.
+		 */
+                
+
+		
+		if (status & SD_STATUS_DD) {
+			if (dma) {
+				au1x_mmc_dma_complete(card);
+			} else if (status & SD_STATUS_NE) {
+				/*
+				 *  Make sure we got it all.
+				 */
+				au1x_mmc_receive_data_pio(card);
+			}
+
+			if (card->m_req->block_len != card->m_cnt) {
+				card->m_req->result = MMC_ERROR_CRC;
+				DEBUG(0, ": Incomplete transfer %s - 0x%08x\n",
+					tx ? "writing" : "reading",
+					status);
+			}
+			del_timer_sync(&card->m_irq_timer);
+			mmc_cmd_complete(card->m_req);
+			card->m_req = 0;
+			card->m_cnt = 0;
+			if (tx) {
+				card->m_flags &= ~AU_MMC_STATE_XMIT_ACTIVE;
+			}
+
+			if (! dma ) {
+				au_writel(au_readl(CARD_CONFIG(card))
+					   & ~(SD_CONFIG_TH | SD_CONFIG_RH),
+					CARD_CONFIG(card));
+				au_sync();
+			}
+		}
+
+		/*
+		 *  Depending on timing, x_NE and x_DD may
+		 *  both be asserted momentarily in the status
+		 *  word, thus we test to see if we still have
+		 *  an outstanding request.
+		 */
+		if ((card->m_req) && (status & SD_STATUS_NE)) {
+
+                        if (dma) {
+				au1x_mmc_receive_data_dma(card);
+			} else {
+				au1x_mmc_receive_data_pio(card);
+			}
+		}
+
+		
+		/* clear the bits - errors and all */
+		au_writel(status, CARD_STATUS(card));
+		au_sync();
+		continue;
+
+terminate_int:
+		/* clear the bits - errors and all */
+		au_writel(status, CARD_STATUS(card));
+		au_sync();
+
+		/* clean up after ourselves */
+		del_timer_sync(&card->m_irq_timer);
+		mmc_cmd_complete(card->m_req);
+		card->m_req = 0;
+		card->m_cnt = 0;
+
+		/*
+		 *  This sequence signals state changes to the upper layer that
+		 *  allow it to gracefully clean up and reset us from above.
+		 *  This will result in controller and dma channel resetting.
+		 */
+		mmc_eject(0);
+		mmc_insert(0);
+	}
+
+	enable_irq(AU1X_MMC_INT);
+}
+
+
+static void mmc_irq_timeout(unsigned long id)
+{
+	au1x_mmc_irq(0, (void *)id, 0);
+}
+
+
+static void au1x_mmc_send_cmd(struct mmc_request *req)
+{
+	int mmc = CTLR_SELECT(req->index);
+	struct au1x_mmc_card *card = au1x_mmc_cards[mmc];
+	u32 mmc_cmd = 0;
+	u32 config = 0;
+
+	DEBUG(2, ": card (%d) command = %d\n", mmc, req->cmd);
+
+	card->m_flags &= ~AU_MMC_STATE_XMIT_ACTIVE;
+
+	/*
+	 *  Establish command type.
+	 */
+	switch (req->cmd) {
+
+	case MMC_CIM_RESET:
+		del_timer_sync(&card->m_irq_timer);
+		del_timer_sync(&card->m_detect_timer);
+		card->m_flags &= ~(AU_MMC_STATE_XMIT_ACTIVE | AU_MMC_STATE_RECV_DMA_IN_USE);
+		card->m_req = 0;
+		card->m_cnt = 0;
+
+		if (card->m_xmit_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+			disable_dma(card->m_xmit_dma);
+#endif
+#ifdef CONFIG_SOC_AU1200
+		  au1xxx_dbdma_stop((u32)(card->ctp_tx));
+#endif
+			au_sync();
+		}
+		if (card->m_recv_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+			disable_dma(card->m_recv_dma);
+#endif
+#ifdef CONFIG_SOC_AU1200
+		  au1xxx_dbdma_stop((u32)(card->ctp_rx));
+#endif
+			au_sync();
+		}
+
+		mmc_power_off(mmc);
+		req->result = mmc_reset_controller(card, MMC_CLOCK_SLOW);
+
+
+         	if ( au1x_mmc_check_insert(mmc) ) {
+			mmc_power_on(mmc);
+			DEBUG(1, ": re-powering on MMC/SD card #%d\n", mmc);
+		}
+		mod_timer(&card->m_detect_timer, jiffies + MMC_DETECT_TIMEOUT);
+
+		if (card->m_xmit_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+			init_dma(card->m_xmit_dma);
+#endif
+#ifdef CONFIG_SOC_AU1200
+		  au1xxx_dbdma_reset((u32)(card->ctp_tx));
+#endif
+			au_sync();
+		}
+		if (card->m_recv_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+			init_dma(card->m_recv_dma);
+#endif
+#ifdef CONFIG_SOC_AU1200
+			au1xxx_dbdma_reset((u32)(card->ctp_rx));
+#endif
+			au_sync();
+		}
+
+		mmc_cmd_complete(req);
+		return;
+
+	case MMC_WRITE_BLOCK:
+		card->m_flags |= AU_MMC_STATE_XMIT_ACTIVE;
+
+		mmc_cmd |= SD_CMD_CT_1;
+		break;
+
+	case MMC_READ_SINGLE_BLOCK:
+		if ( card->m_flags & AU_MMC_STATE_USE_DMA ) {
+			config |= SD_CONFIG_NE;
+		} else {
+			/* enable recv ready for PIO mode */
+			config |= SD_CONFIG_RH;
+		}
+
+		mmc_cmd |= SD_CMD_CT_2;
+		break;
+
+	case MMC_WRITE_MULTIPLE_BLOCK:	/* SD_CMD_CT_3 */
+	case MMC_READ_MULTIPLE_BLOCK:	/* SD_CMD_CT_4 */
+	case MMC_STOP_TRANSMISSION:	/* SD_CMD_CT_7 */
+	  {
+		u32 ctype=0;
+		switch (req->cmd) {
+		case MMC_WRITE_MULTIPLE_BLOCK:	ctype = SD_CMD_CT_3; break;
+		case MMC_READ_MULTIPLE_BLOCK:	ctype = SD_CMD_CT_4; break;
+		case MMC_STOP_TRANSMISSION:	ctype = SD_CMD_CT_7; break;
+		}
+		DEBUG(0, ": Unsupported MMC command type: %d\n", ctype);
+
+		req->result = MMC_ERROR_ILLEGAL_COMMAND;
+		mmc_cmd_complete(req);
+		return;
+	  }
+
+	default:
+		if (req->nob) {
+			DEBUG(0, ": Data blocks (%d) for non-I/O command %d\n",
+				req->nob, req->cmd);
+
+			req->result = MMC_ERROR_DRIVER_FAILURE;
+			mmc_cmd_complete(req);
+			return;
+		}
+		break;
+	}
+
+	/*
+	 *  Insert upper level command.
+	 */
+	mmc_cmd |= req->cmd << SD_CMD_CI_SHIFT;
+
+	/*
+	 *  Deal with only one data block at a time.
+	 */
+	if (req->nob && req->nob != 1) {
+		DEBUG(0, ": Too many data blocks (%d) for command %d\n",
+			req->nob, req->cmd);
+
+		req->result = MMC_ERROR_DRIVER_FAILURE;
+		mmc_cmd_complete(req);
+		return;
+	}
+
+	/*
+	 *  Establish response type.
+	 */
+	switch (req->rtype) {
+
+	case RESPONSE_NONE:
+		mmc_cmd |= SD_CMD_RT_0;
+		break;
+
+	case RESPONSE_R1:
+		mmc_cmd |= SD_CMD_RT_1;
+		break;
+
+	case RESPONSE_R1B:
+		mmc_cmd |= SD_CMD_RT_1B;
+		break;
+
+	case RESPONSE_R2_CID:
+	case RESPONSE_R2_CSD:
+		mmc_cmd |= SD_CMD_RT_2;
+		break;
+
+	case RESPONSE_R3:
+		mmc_cmd |= SD_CMD_RT_3;
+		break;
+
+	case RESPONSE_R4:
+	case RESPONSE_R5:
+	default:
+		DEBUG(0, ": Unsupported MMC response type %d\n", req->rtype);
+
+		req->result = MMC_ERROR_ILLEGAL_COMMAND;
+		mmc_cmd_complete(req);
+		return;
+	}
+
+	card->m_req = req;
+	card->m_cnt = 0;
+
+	/*
+	 *  Prime timeout before we do anything that might trigger
+	 *  an interrupt that could possibly disarm the timer.
+	 */
+	mod_timer(&card->m_irq_timer, jiffies + MMC_IRQ_TIMEOUT);
+
+	/*
+	 *  Set any command-specific IRQ bits.
+	 */
+	if (config) {
+
+		au_writel(au_readl(CARD_CONFIG(card)) | config,
+			CARD_CONFIG(card));
+		au_sync();
+	}
+
+	/*
+	 *  Command argument must be written first.
+	 */
+	au_writel(req->arg, CARD_CMDARG(card));
+
+	/*
+	 *  Block count and size next.
+	 */
+	if (req->nob) {
+		/*
+		 *  Value programmed is one less than the actual
+		 *  number of bytes in the block.
+		 */
+		au_sync();	/* ordered writes */
+		au_writel(((req->block_len-1) << SD_BLKSIZE_BS_SHIFT)
+				  | (req->nob << SD_BLKSIZE_BC_SHIFT),
+			CARD_BLKSIZE(card));
+	}
+
+	/*
+	 *  Make sure state is updated before starting command.
+	 */
+	au_sync();	/* ordered writes */
+	au_writel((mmc_cmd | SD_CMD_GO), CARD_CMD(card));
+}
+
+
+static int au1x_mmc_check_insert(int mmc)
+{
+	int ins=0;
+
+
+	mmc_card_inserted(mmc, &ins);
+
+        
+	/*
+	 *  Update our own sense of presence.
+	 */
+	if (ins)
+		au1x_mmc_cards[mmc]->m_isempty = 0;
+	else
+		au1x_mmc_cards[mmc]->m_isempty = 1;
+
+	return ( ins );
+	
+               
+}
+
+
+static int au1x_mmc_is_empty(int slot)
+{
+	return ( au1x_mmc_cards[CTLR_SELECT(slot)]->m_isempty );
+}
+
+
+static void mmc_detect_timeout(unsigned long id)
+{
+	struct au1x_mmc_card *card = (struct au1x_mmc_card *) id;
+	int mmc = card->m_ctlr;
+	int old, new;
+
+	old = ! card->m_isempty;
+	new = au1x_mmc_check_insert(mmc);
+
+	if(old != new) {
+
+		DEBUG(1, ": isempty changed %d\n", new);
+		if (new) {
+			DEBUG(1, ": insert\n");
+			mmc_power_on(mmc);
+			DEBUG(1, ": powering on MMC/SD card #%d\n", mmc);
+			mmc_insert(0);
+		} else {
+			DEBUG(1, ": eject\n");
+			mmc_power_off(mmc);
+			DEBUG(1, ": powering off MMC/SD card #%d\n", mmc);
+			mmc_eject(0);
+		}
+	}
+
+	mod_timer(&card->m_detect_timer, jiffies + MMC_DETECT_TIMEOUT);
+}
+
+
+static int do_set_clock(struct au1x_mmc_card *card, u32 rate)
+{
+	unsigned int pbus = get_au1x00_speed();
+	unsigned int divisor;
+	u32 sd_config;
+
+	DEBUG(1, ": MMC clk rate=%d(0x%x) for ctlr #%d, cpu clk:%d(0x%x)\n", rate, rate, card->m_ctlr, pbus, pbus);
+
+	/*
+	 * Calculate appropriate DIVisor:
+	 *
+	 * Databook says 0x000 -> divide by 2
+	 *               0x1ff -> divide by 1024 (0x400)
+	 * peripheral clock runs at (cpuclock / sbus_divisor) / 2
+	 * so
+	 *    divisor = ((((cpuclock / sbus_divisor) / 2) / mmcclock) / 2) - 1
+	 */
+	pbus /= ((au_readl(SYS_POWERCTRL) & 0x3) + 2);
+	pbus /= 2;
+
+	divisor = ((pbus / rate) / 2) - 1;
+	DEBUG(1, ": divisor is 0x%x\n", divisor);
+
+	sd_config = au_readl(CARD_CONFIG(card)) & ~(SD_CONFIG_DIV);
+	sd_config |= ((divisor & SD_CONFIG_DIV) | SD_CONFIG_DE);
+	au_writel(sd_config, CARD_CONFIG(card));
+	au_sync();
+
+	card->m_clock = rate;	/* save rate away for use in possible reset */
+
+	return MMC_NO_ERROR;
+}
+
+
+static int mmc_reset_controller(struct au1x_mmc_card *card, u32 rate)
+{
+	int rv = MMC_NO_ERROR;
+
+	/*
+	 *  Enable controller via reset sequence.
+	 *  Data book says first enable clock,
+	 *  then take peripheral out of reset.
+	 */
+	au_writel(SD_ENABLE_CE, CARD_ENABLE(card));
+	au_sync_delay(1);
+	au_writel((SD_ENABLE_R | SD_ENABLE_CE), CARD_ENABLE(card));
+	au_sync_delay(1);
+
+	/*
+	 *  Clear out any bogus events.
+	 */
+	au_writel(~0, CARD_STATUS(card));
+	au_sync();	/* ordered writes */
+
+	/*
+	 *  Set max timeout - 21 bits - rest are reserved.
+	 */
+	au_writel(0, CARD_BLKSIZE(card));
+	au_writel(0x001fffff, CARD_TIMEOUT(card));
+	au_sync();	/* ordered writes */
+
+	/*
+	 *  Enable serial interface state machine and FIFO master.
+	 */
+	au_writel(SD_CONFIG2_EN, CARD_CONFIG2(card));	/* enable */
+	au_sync();	/* ordered writes */
+	au_writel(SD_CONFIG2_EN | SD_CONFIG2_FF, CARD_CONFIG2(card));	/* flush/reset FIFO */
+	au_sync();	/* ordered writes */
+	au_writel(SD_CONFIG2_EN, CARD_CONFIG2(card));	/* clear sticky flush bit */
+	au_sync();	/* ordered writes */
+
+	/*
+	 *  Enable interrupts.
+	 */
+	au_writel((SD_CONFIG_I |	/* master enable */
+		   SD_CONFIG_CR |	/* command response */
+		   SD_CONFIG_DD),	/* xfer done */
+		CARD_CONFIG(card));
+	au_sync();	/* ordered writes */
+
+	rv = do_set_clock(card, rate);
+
+	return rv;
+}
+
+
+static int au1x_mmc_set_clock(int slot, u32 rate)
+{
+	int mmc = CTLR_SELECT(slot);
+	struct au1x_mmc_card *card = au1x_mmc_cards[mmc];
+
+	return (do_set_clock(card, rate));
+}
+
+
+static int au1x_mmc_init(void)
+{
+	int mmc, ret;
+#ifdef CONFIG_SOC_AU1200
+	chan_tab_t *chanpt;
+#endif
+
+	/*
+	 *  Get irq.  Last arg used to distinguish timeouts.
+	 *  Service routine will scan all controllers.
+	 */
+	ret = request_irq(AU1X_MMC_INT, au1x_mmc_irq,
+				SA_SHIRQ | SA_INTERRUPT,
+				"MMC", au1x_mmc_cards/* must be non-NULL */);
+
+       
+	if(ret) {
+		DEBUG(0, ": request_irq() failed %d(0x%x).\n", -ret, -ret);
+		return ret;
+	}
+	disable_irq(AU1X_MMC_INT);
+
+	for (mmc = 0; mmc < NUM_MMC_CONTROLLERS; ++mmc) {
+
+		struct au1x_mmc_card *card = au1x_mmc_cards[mmc];
+
+		/*
+		 *  Process boot option(s)
+		 */
+		if ( au1x_mmc_use_pio ){
+			card->m_flags &= ~AU_MMC_STATE_USE_DMA; 
+                  
+                        
+		}else{
+			card->m_flags |= AU_MMC_STATE_USE_DMA;
+		}
+		if ( !au1x_mmc_dbl_buf && !au1x_mmc_use_pio ){
+			card->m_flags |= AU_MMC_STATE_DOUBLE_BUFFER_DMA;
+			
+		}else{
+			card->m_flags &= ~AU_MMC_STATE_DOUBLE_BUFFER_DMA;
+			
+                 }
+		if ( (au1x_mmc_ctlr == mmc) || ((unsigned)au1x_mmc_ctlr >= NUM_MMC_CONTROLLERS) )
+			card->m_flags |= AU_MMC_STATE_CTLR_ACTIVE;
+		else
+			card->m_flags &= ~AU_MMC_STATE_CTLR_ACTIVE;
+
+		/*
+		 *  Punt if this controller has been designated inactive.
+		 */
+		if ( ! (card->m_flags & AU_MMC_STATE_CTLR_ACTIVE) )
+			continue;
+
+		/*
+		 *  Assign this active controller to handle incoming requests.
+		 */
+		if (mmc_active_ctlr < 0)
+			mmc_active_ctlr = mmc;
+
+		/*
+		 *  Possibly redundant, as protocol sequence does a reset
+		 *  once a card is inserted.
+		 */
+		mmc_reset_controller(card, card->m_clock);
+
+		/*
+		 *  Detect card.
+		 */
+
+		if ( au1x_mmc_check_insert(mmc) ) {
+		  
+			mmc_power_on(mmc);
+                  
+			DEBUG(1, ": powering on MMC/SD card #%d\n", mmc);
+		}
+
+		/*
+		 *  Attach DMA resources.
+		 */
+		ret = -1;
+		if ( card->m_flags & AU_MMC_STATE_USE_DMA ) {
+
+			DEBUG(1, ": allocating TX DMA chan for MMC #%d\n", mmc);
+#ifdef CONFIG_SOC_AU1100
+			ret = card->m_xmit_dma =
+				request_au1000_dma(card->m_tx_dma_devid,
+								card->m_tx_dma_str,
+								NULL, 0, NULL);
+#endif
+#ifdef CONFIG_SOC_AU1200
+			card->ctp_tx=(chan_tab_t **)au1xxx_dbdma_chan_alloc(DSCR_CMD0_ALWAYS, 
+					(u32)(card->m_tx_dma_devid),
+					(void(*)())NULL, 
+					(void (*)())NULL);
+				chanpt = *((chan_tab_t**)(card->ctp_tx));
+				ret = card->m_xmit_dma=chanpt->chan_index;
+#endif
+
+			if (ret < 0) {
+				DEBUG(0, ": Request %s DMA failed %d(0x%x).\n",
+					card->m_tx_dma_str,
+					-ret, -ret);
+#ifdef CONFIG_SOC_AU1200
+			}else{
+			 
+			  /* Descriptor Ring Buffer Allocation  and Device Width 
+			   * 
+			   */
+                               	
+			      	au1xxx_dbdma_set_devwidth((u32)(card->ctp_tx), 8);
+			
+			        
+			         if (au1xxx_dbdma_ring_alloc((u32)(card->ctp_tx), NUM_DBDMA_DESCRIPTORS) == 0){
+				
+				  	DEBUG(0, ": Request %s DDMA Descriptor Ring Buffer Allocation failed %d(0x%x).\n",
+					      card->m_tx_dma_str);
+					 
+					au1xxx_dbdma_chan_free((u32)(card->ctp_tx));
+					
+					card->m_xmit_dma = -1;
+					ret = -1;
+				}
+#endif
+			
+			} 
+		}
+
+		if (ret >= 0) {
+
+			DEBUG(1, ": allocating RX DMA chan for MMC #%d\n", mmc);
+
+#ifdef CONFIG_SOC_AU1100
+			ret = card->m_recv_dma =
+				request_au1000_dma(card->m_rx_dma_devid,
+								card->m_rx_dma_str,
+								NULL, 0, NULL);
+#endif
+#ifdef CONFIG_SOC_AU1200
+			card->ctp_rx=(chan_tab_t **)au1xxx_dbdma_chan_alloc((u32)(card->m_rx_dma_devid),
+					DSCR_CMD0_ALWAYS,
+					(void(*)())NULL, 
+					(void (*)())NULL); 
+			ret = card->m_recv_dma=(*(card->ctp_rx))->chan_index;
+#endif
+
+			if (ret < 0) {
+				DEBUG(0, ": Request %s DMA failed %d(0x%x).\n",
+					card->m_rx_dma_str,
+					-ret, -ret);
+
+				/* undo xmit allocation */
+				if (card->m_xmit_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+					free_au1000_dma(card->m_xmit_dma);
+					card->m_xmit_dma = -1;
+#endif
+#ifdef CONFIG_SOC_AU1200
+					au1xxx_dbdma_chan_free((u32)(card->ctp_tx));
+					card->m_xmit_dma = -1;
+				}
+			} else {
+				au1xxx_dbdma_set_devwidth((u32)(card->ctp_rx), 8);
+				if (au1xxx_dbdma_ring_alloc((u32)(card->ctp_rx), NUM_DBDMA_DESCRIPTORS) == 0) {
+					DEBUG(0, ": Request %s DDMA Descriptor Ring Buffer Allocation failed %d(0x%x).\n",
+						card->m_tx_dma_str);
+
+					au1xxx_dbdma_chan_free((u32)(card->ctp_tx));
+					card->m_xmit_dma = -1;
+					au1xxx_dbdma_chan_free((u32)(card->ctp_rx));
+					card->m_recv_dma = -1;
+					ret = -1;
+#endif
+				}
+			}
+		}
+
+		/* Get memory for any DMA double-buffering. */
+		if ((ret >= 0) && (card->m_flags & AU_MMC_STATE_DOUBLE_BUFFER_DMA)) {
+			void *mem1, *mem2;
+			int memsize;
+
+			/* maximum size (bytes) of MMC transaction */
+			memsize = (SD_BLKSIZE_BS >> SD_BLKSIZE_BS_SHIFT) + 1;
+
+			/* round maximum bytes up to next page boundary */
+			memsize = (memsize + PAGE_SIZE - 1) & PAGE_MASK;
+
+			mem1 = (void *)__get_free_pages(GFP_ATOMIC | GFP_DMA,
+						     get_order(memsize));
+			mem2 = (void *)__get_free_pages(GFP_ATOMIC | GFP_DMA,
+						     get_order(memsize));
+
+			if (mem1 != NULL && mem2 != NULL) {
+				memset(mem1, 0, memsize);
+				memset(mem2, 0, memsize);
+				card->m_tx_rawbuf = mem1;
+				card->m_rx_rawbuf = mem2;
+				card->m_tx_dmaaddr = (dma_addr_t)mem1; // was virt_to_phys(mem1);
+				card->m_rx_dmaaddr = (dma_addr_t)mem2; // was virt_to_phys(mem2);
+
+				card->m_dma_memsize = memsize;
+
+			} else {
+
+				ret = -1;
+				/*
+				 *  Release resources and fall back to PIO.
+				 */
+				DEBUG(0, ": DMA buffer allocation(s) failed"
+					" (0x%x 0x%x).\n",
+					(unsigned int)mem1,
+					(unsigned int)mem2);
+
+				if (mem1 != NULL) {
+					free_pages((unsigned long)mem1,
+						get_order(memsize));
+				}
+				if (mem2 != NULL) {
+					free_pages((unsigned long)mem2,
+						get_order(memsize));
+				}
+#ifdef CONFIG_SOC_AU1100
+				free_au1000_dma(card->m_xmit_dma);
+				card->m_xmit_dma = -1;
+				free_au1000_dma(card->m_recv_dma);
+				card->m_recv_dma = -1;
+#endif
+#ifdef CONFIG_SOC_AU1200
+				au1xxx_dbdma_chan_free((u32)(card->ctp_tx));
+				au1xxx_dbdma_chan_free((u32)(card->ctp_rx));
+#endif
+			}
+		}
+
+		/*
+		 *  Fall back to PIO if DMA setup fails.
+		 */
+		if ((ret < 0) && (card->m_flags & AU_MMC_STATE_USE_DMA)) {
+			card->m_flags &= ~(AU_MMC_STATE_USE_DMA | AU_MMC_STATE_DOUBLE_BUFFER_DMA);
+			DEBUG(0,": MMC #%d DMA setup failed - using PIO\n",mmc);
+		}
+
+		/*
+		 *  Prime the detection timer.
+		 */
+		mod_timer(&card->m_detect_timer, jiffies + MMC_DETECT_TIMEOUT);
+	}
+	au1x_mmc_cards[0]->m_flags |= AU_MMC_STATE_MODULE_INITTED;
+
+	enable_irq(AU1X_MMC_INT);
+
+	return MMC_NO_ERROR;
+}
+
+
+static void au1x_mmc_cleanup(void)
+{
+	int mmc, flags;
+	struct au1x_mmc_card *card;
+
+	/*
+	 *  Punt if we've been here before.
+	 */
+	flags = au1x_mmc_cards[0]->m_flags;
+	au1x_mmc_cards[0]->m_flags &= ~AU_MMC_STATE_MODULE_INITTED;
+	if ( ! (flags & AU_MMC_STATE_MODULE_INITTED) )
+		return;
+
+	disable_irq(AU1X_MMC_INT);
+
+	/*
+	 *  Free resources.
+	 */
+	au_sync();	/* ordered writes */
+	for (mmc = 0; mmc < NUM_MMC_CONTROLLERS; ++mmc) {
+		card = au1x_mmc_cards[mmc];
+
+		/*
+		 *  Punt timers.
+		 */
+		del_timer_sync(&card->m_detect_timer);
+		del_timer_sync(&card->m_irq_timer);
+
+		/*
+		 *  Unattach DMA.
+		 */
+		if (card->m_tx_rawbuf != NULL) {
+			free_pages((unsigned long)card->m_tx_rawbuf,
+				get_order(card->m_dma_memsize));
+			card->m_tx_rawbuf = NULL;
+		}
+		if (card->m_rx_rawbuf != NULL) {
+			free_pages((unsigned long)card->m_rx_rawbuf,
+				get_order(card->m_dma_memsize));
+			card->m_rx_rawbuf = NULL;
+		}
+		if (card->m_xmit_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+			free_au1000_dma(card->m_xmit_dma);
+			card->m_xmit_dma = -1;
+#endif
+#ifdef CONFIG_SOC_AU1200
+		  au1xxx_dbdma_chan_free((u32)card->ctp_tx); 
+#endif
+		}
+		if (card->m_recv_dma >= 0) {
+#ifdef CONFIG_SOC_AU1100
+			free_au1000_dma(card->m_recv_dma);
+			card->m_recv_dma = -1;
+#endif
+#ifdef CONFIG_SOC_AU1200
+		  au1xxx_dbdma_chan_free((u32)card->ctp_rx);
+#endif
+		}
+
+		/*
+		 *  Leave cards powered off.
+		 */
+		mmc_power_off(mmc);
+
+		/*
+		 *  Disable controllers.
+		 */
+		au_writel(0, CARD_ENABLE(card));
+		au_sync();	/* ordered writes */
+	}
+
+	/* 2nd arg must match dev_id in request_irq */
+	free_irq(AU1X_MMC_INT, au1x_mmc_cards);
+}
+
+
+static int __init au1x_mmc_module_init(void)
+{
+	int mmc;
+	struct au1x_mmc_card *card;
+
+	for (mmc = 0; mmc < NUM_MMC_CONTROLLERS; ++mmc) {
+
+		/*
+		 *  Complete basic init of controller descriptor (timers, etc).
+		 */
+		card = au1x_mmc_cards[mmc] = &au1x_mmc_card_table[mmc];
+
+		card->m_irq_timer.function = mmc_irq_timeout;
+		card->m_irq_timer.data = (unsigned long) card;
+		init_timer(&card->m_irq_timer);
+
+		card->m_detect_timer.function = mmc_detect_timeout;
+		card->m_detect_timer.data = (unsigned long) card;
+		init_timer(&card->m_detect_timer);
+
+		/*
+		 *  Leave cards powered off until insertion detected.
+		 */
+		mmc_power_off(mmc);
+
+		/*
+		 *  Leave peripheral clock disabled to conserve power.
+		 */
+		au_writel(0, CARD_ENABLE(card));
+		au_sync();	/* ordered writes */
+	}
+
+	/*
+	 *  Insert self into MMC framework, indicating number of slots
+	 *  the controller is servicing.
+	 *
+	 *  The framework supports a single controller but with possibly
+	 *  multiple slots.  A specific slot can be encoded into the
+	 *  command argument.  The Au1x supports a dual-controller, each
+	 *  with a single slot.  We report to the upper layer that we
+	 *  handle only one slot; the active controller is selected at
+	 *  boot-time/module-load-time.
+	 */
+	return mmc_register_slot_driver(&au1x_mmc_driver, 1);
+}
+
+
+static void __exit au1x_mmc_module_exit(void)
+{
+#if defined(CONFIG_MMC_MODULE_UNIFIED)
+	/*
+	 *  If the outer framework and this driver are bound together
+	 *  as a single module, care must be taken on module unload.
+	 *  Ideally we should unregister the slot driver.  However, at
+	 *  module_exit time the upper layers may have already cleaned
+	 *  up and exited; and in fact it turns out the unregistration
+	 *  primitive would restart/reschedule a tasklet that otherwise
+	 *  has been terminated.  Presumably a memory management fault
+	 *  would occur when the tasklet runs after module removal.
+	 *
+	 *  So, if a user takes care to unmount and eject media before
+	 *  removing this module, much of the necessary cleanup will
+	 *  happen as a result of that.  About all we need to do is
+	 *  release local resources and quiesce the hardware.
+	 */
+	au1x_mmc_cleanup();
+#else
+	/*
+	 *  Remove reference counts on the upper framework.
+	 */
+	mmc_unregister_slot_driver(&au1x_mmc_driver);
+	au1x_mmc_cleanup();	/* possibly redundant */
+#endif
+}
+
+
+module_init(au1x_mmc_module_init);
+module_exit(au1x_mmc_module_exit);
+
+
+/* boot/load options - non-module */
+#ifndef MODULE
+static int __init usepio_setup(char *str)
+{
+	au1x_mmc_use_pio = simple_strtol(str, NULL, 0);
+	return 1;
+}
+static int __init dblbuf_setup(char *str)
+{
+	au1x_mmc_dbl_buf = simple_strtol(str, NULL, 0);
+	return 1;
+}
+static int __init ctlr_setup(char *str)
+{
+	au1x_mmc_ctlr = simple_strtol(str, NULL, 0);
+	return 1;
+}
+
+__setup("au1x_mmc_use_pio=", usepio_setup);
+__setup("au1x_mmc_dbl_buf=", dblbuf_setup);
+__setup("au1x_mmc_ctlr=", ctlr_setup);
+#endif
+
+/* boot/load options - module */
+MODULE_PARM(au1x_mmc_use_pio, "i");
+MODULE_PARM_DESC(au1x_mmc_use_pio, "Force PIO - default is use DMA channels.");
+
+MODULE_PARM(au1x_mmc_dbl_buf, "i");
+MODULE_PARM_DESC(au1x_mmc_dbl_buf, "For DMA, double buffer - use for unaligned requests.");
+
+MODULE_PARM(au1x_mmc_ctlr, "i");
+MODULE_PARM_DESC(au1x_mmc_ctlr, "Which SD controller to enable (0, 1, or 2(both)) -- SD0 is default.");
+
+MODULE_AUTHOR("Embedded Edge, LLC.");
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Au1x00 MultiMediaCard controller support");
+
+
